namespace :miners do
  task miners_status_notification: :environment do
    require 'logger'
    require 'telegram_bot'

    TELEGRAM_BOT_TOKEN = "5829604433:AAG5CeFBygU1lvV5oeeDyT_v0CqzjAWCNlY"
    CHAT_ID = "-1001516309000"

    bot = TelegramBot.new(token: TELEGRAM_BOT_TOKEN, logger: Logger.new(STDOUT))
    channel = TelegramBot::Channel.new(id: CHAT_ID)
    message = TelegramBot::OutMessage.new
    message.chat = channel

    miss_miner = Miner.where(status: Miner::STATUSES[0])
    restart_miner = Miner.where(status: Miner::STATUSES[2])
    active_miner = Miner.where(status: Miner::STATUSES[1])

    message.text = "Date: #{DateTime.now.strftime("%d.%m.%Y %H:%M")}\n
  Total: #{Miner.count}\n
  Active: #{active_miner.count}\n
  Restart: #{restart_miner.count}\n
    #{restart_miner.map(&:name).join(', ')}\n
  Miss: #{miss_miner.count}\n
    #{miss_miner.map(&:name).join(', ')}
    "
    message.send_with(bot)
  end


  task check_active_list: :environment do
    url = 'http://144.202.99.58:4243/active_list'
    response = HTTParty.get(url)

    response_json = JSON.parse(response.body)
    time = DateTime.now
    miners = Miner.all

    if response_json == []
      miners.update_all(status: Miner::STATUSES[0])
    end

    miners.each do |miner|
      if miner.status == Miner::STATUSES[2]
        next
      end
      is_work = false
      hr_stats = 0
      check_activity_time = (DateTime.now - 5.minutes)
      last_activity_time = miner.last_activity || check_activity_time

      response_json.each do |item|
        if item['work_id'] == miner.name
          is_work = true
          hr_stats = item["hr_stats"]
          break
        end
      end

      if is_work
        miner.update(status: Miner::STATUSES[1], hash_rate: hr_stats)
      else
        if last_activity_time <= check_activity_time
          miner.update(status: Miner::STATUSES[0], last_activity: time, hash_rate: hr_stats)
        end
      end
    end
  end

  task check_safex_active_miner: :environment do
    url = 'http://pools.simbowear.com:8117/stats_address?address=Safex5ztaoiBsGxatonmfJfVvEufBEDrRNY4Ha2zTJrf8HSHrB8atKB55VPBAkwmrK6UQZsCNJmLLXKtumBPEEHw5FDrEYzDzWQ4S&longpoll=false'
    response = HTTParty.get(url)

    response_json = JSON.parse(response.body)
    time = DateTime.now
    miners = Miner.all

    if response_json == []
      miners.update_all(status: Miner::STATUSES[0])
    end
    puts response_json['workers'][0]['name']

    miners.each do |miner|
      if miner.status == Miner::STATUSES[2]
        next
      end
      is_work = false
      hr_stats = 0
      check_activity_time = (DateTime.now - 5.minutes)
      last_activity_time = miner.last_activity || check_activity_time

      response_json['workers'].each do |item|
        if item['name'] == miner.name && item['hashrate'] > 0
          is_work = true
          hr_stats = item["hashrate"]
          puts item["hashrate"]
          break
        end
      end

      if is_work
        miner.update(status: Miner::STATUSES[1], hash_rate: hr_stats)
      else
        if last_activity_time <= check_activity_time
          miner.update(status: Miner::STATUSES[0], last_activity: time, hash_rate: hr_stats)
        end
      end
    end
  end

  task get_miners_data: :environment do
    session = GoogleDrive::Session.from_service_account_key("client_secret.json")
    spreadsheet ||= session.spreadsheet_by_title("bsa_miners")
    @worksheet = spreadsheet.worksheets.first

    NAME = 1
    IP_ADDRESS = 4
    PORT = 5
    ADDRESS = 6
    PASS = 7
    ALGORITHM = 8
    IP_ADDRESS_2 = 9
    PORT_2 = 10
    ADDRESS_2 = 11
    PASS_2 = 12
    ALGORITHM_2 = 13

    row = 2
    col = 1

    @worksheet.rows.each_with_index do |cell, index|
      if @worksheet[index + row, NAME] == ""
        break
      end

      miner = Miner.find_by(name: @worksheet[index + row, NAME])
      if miner.present?
        miner.update(
          ip_address: @worksheet[index + row, IP_ADDRESS],
          port: @worksheet[index + row, PORT],
          wallet_address: @worksheet[index + row, ADDRESS],
          pass: @worksheet[index + row, PASS],
          algorithm: @worksheet[index + row, ALGORITHM],
          ip_address_2: @worksheet[index + row, IP_ADDRESS_2],
          port_2: @worksheet[index + row, PORT_2],
          wallet_address_2: @worksheet[index + row, ADDRESS_2],
          pass_2: @worksheet[index + row, PASS_2],
          algorithm_2: @worksheet[index + row, ALGORITHM_2])
      else
        Miner.create(
          name: @worksheet[index + row, NAME],
          ip_address: @worksheet[index + row, IP_ADDRESS],
          port: @worksheet[index + row, PORT],
          wallet_address: @worksheet[index + row, ADDRESS],
          pass: @worksheet[index + row, PASS],
          algorithm: @worksheet[index + row, ALGORITHM],
          ip_address_2: @worksheet[index + row, IP_ADDRESS_2],
          port_2: @worksheet[index + row, PORT_2],
          wallet_address_2: @worksheet[index + row, ADDRESS_2],
          pass_2: @worksheet[index + row, PASS_2],
          algorithm_2: @worksheet[index + row, ALGORITHM_2])
      end
    end
  end
end